$engine JScript
$uname mdNavigator
$dname   


function printMdObj(mdObj, indent, text, parentName)
{
    //     
    var mdc = mdObj.mdclass;
	var curName;
	if (mdObj == metadata.current.rootObject) {
		curName = "";
	}
	else{
		curName = (parentName == "" ? "" : parentName + ".") + mdc.name(1) + "." + mdObj.property("");		
	};
	    
	text.push(curName + "|" + mdObj.id);
    
	//    (    , , )
    for(var i = 0; i < mdc.childsClassesCount; i++)
    {
        var childMdClass = mdc.childClassAt(i)
		// 
		if (childMdClass.name(1, true) == "") {continue;};
		
        //      .
        for(var chldidx = 0, c = mdObj.childObjectsCount(i); chldidx < c; chldidx++){
			var childObject = mdObj.childObject(i, chldidx);
			printMdObj(childObject, indent + "\t", text, curName);
		}
    }
}

function PropsOfMdObj(mdObj){
	var text = []
	var mdc = mdObj.mdclass
	var okStr = ",,,,,";
	
	for(var i = 0, c = mdc.propertiesCount; i < c; i++)
    {
        var mdPropName = mdc.propertyAt(i).name(1);
		if (okStr.search(mdPropName + '\,') != -1)
			text.push(mdPropName);
    }
	
	return text;
}

SelfScript.self['macros  '] = function() 
{
	text = [];
	printMdObj(metadata.current.rootObject, "", text, "");
	
	var svc = new ActiveXObject("Svcsvc.Service");
	var Path =  "";
	//Path = svc.SelectInTree(text.join('\n'),"", false , false);
	Path = svc.FilterValue(text.join('\n'),1 + 512,"",0,0)
	
	var re = /(\S+\|)(\S+)/
	Path = Path.replace(re, "$2")
	
	if (Path == "") return;
		
	var nObject = metadata.current.rootObject;
	if (nObject.id != Path)
		nObject = metadata.current.findByUUID(Path);
		
	var arProps = PropsOfMdObj(nObject);
	var propName = "  " + '\n' + "  "; //     
	
	//if (arProps.length > 1)
		var propName = svc.FilterValue(propName + '\n' + arProps.join('\n'), 1 + 512, "", 0, 0)
	
	switch (propName) {
		case "":
			return;
			break;
		case "  ":
			nObject.activateInTree();
			break;
		case "  ":
			nObject.openEditor();
			break;
		default:
			nObject.editProperty(propName);
	}
	
}